/*************************************************
Projet ExoPRJS

Auteur : Jean Marc Wehrlen, 2011

Version 20121208

INDICATION DE LICENCE :
Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier au titre des clauses de la Licence Publique Gnrale Affero GNU, telle que publie par la Free Software Foundation, version 3 ou une version ultrieure de la Licence,  votre choix. 
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. Voir la Licence Publique Gnrale Affero GNU pour plus de dtails : <http://www.gnu.org/licenses/agpl.html>.

LICENSE INDICATION IN ENGLISH :
This program is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for more details: <http://www.gnu.org/licenses/agpl.html>.

*****************************************************/
//making sure that data files config var are declared
var firstCharCaseInsensitive;
var punctuationUnaware;
var preRed;
var neglectSpaces;
var shuffleEntries;
var fixedOrder;
var linkToToc;
var sourcesURL;
var inhibitScorePanel;
var scorePanelVisible;
var dontTellIt;
var promptToken;
var tokenTreatment;

var exoLicense;



//global working variables
var scoreStatus;//array
var regexReplaceBehaviorCode;//boolean


function accessk(ev){
	var e=ev?ev:window.event;
	var t=e.target ? e.target:e.srcElement;
	if (e.keyCode==13) {//when in text input, press enter to check answer
		var i = t.id.substring(1, t.id.length);
		checkIt(rightAnswers[i],acceptedAnswers[i],t.id);
		}
	}

function getI(identifier){
return identifier.substring(1,identifier.length);
}

function checkIt(rightAnswer,accepted,identifier){
//var v="un lphant              , a trompe";alert(v+'\n'+formatPhrase(v));
	var i = getI(identifier);
	var acceptedArray = new Array();
	var t=document.getElementById(identifier);
	var studentsAnswer=t.value;
	if(accepted.indexOf("<sep>")>-1) acceptedArray = accepted.split("<sep>");
	else acceptedArray[0]=accepted;
	for (var j=0;j<acceptedArray.length;j++){
		if(formatPhrase(studentsAnswer)==formatPhrase(acceptedArray[j])) {
			t.value=rightAnswer;
			t.style.backgroundColor="rgb(0,255,0)";
			if(scoreStatus[i]==0)scoreStatus[i]=1;
			if(!inhibitScorePanel&&scorePanelVisible) refreshScorePanel(scoreStatus);
			if(++i<rightAnswers.length) {
				goToNextPrompt(i);
				}
			return;
			}
		}
	if(formatPhrase(studentsAnswer)==formatPhrase(prompts[i])) return;
	t.style.backgroundColor="rgb(250,50,50)";
	if(scoreStatus[i]<1) scoreStatus[i]--;
	}

function goToNextPrompt(nextI){
	if(promptToken=="startOfText" || promptToken=="endOfText"){
		if(nextI<rightAnswers.length) cwFindText(document.getElementById("t"+(nextI)),promptToken,tokenTreatment);
		}
	else if(promptToken) {
				var nextTextInput = document.getElementById("t"+(nextI));
				while(nextI<rightAnswers.length && nextTextInput.value.indexOf(promptToken)==-1) {
					nextTextInput = document.getElementById("t"+(++nextI));
					}
				cwFindText(nextTextInput,promptToken,tokenTreatment);
			}
}


function formatPhrase(str){
	if(punctuationUnaware){
		//str=rpAll(str,/!/g,"");
str=str.replace(/\!/g,"");
		//str=rpAll(str,/\?/g,"");
str=str.replace(/\?/g,"");
		//str=rpAll(str,/:/g,"");
str=str.replace(/:/,"");
		//str=rpAll(str,/;/g,"");
str=str.replace(/;/g,"");
		//str=rpAll(str,/\./g,"");
str=str.replace(/\./g,"");
		//str=rpAll(str,/,/g,"");
str=str.replace(/,/g,"");
		}
	else{
		str=str.replace(/!/g," ! ");
		str=str.replace(/\?/g," ? ");
		str=str.replace(/:/g," : ");
		str=str.replace(/;/g," ; ");
		str=str.replace(/\./g," . ");
		str=str.replace(/,/g," , ");
		//str=rpAll(str,/ ,/g,",");
		//str=rpAll(str,/ \./g,".");
str=str.replace(/ +\./g,".");
str=str.replace(/ +\,/g,",");
		}
	//str=rpAll(str,/ '/g,'\'');
	//str=rpAll(str,/' /g,'\'');
str=str.replace(/ *' */g,'\'');
	//str=rpAll(str,/\( /g,'(');
str=str.replace(/ *\( */g,' (');
	//str=rpAll(str,/ \)/g,')');
str=str.replace(/ *\) */g,') ');
	//str=str.replace(/\(/g,' (');
	//str=str.replace(/\)/g,') ');
	if(neglectSpaces) {
		//str=rpAll(str,/ /g,'');//standardiser en supprimant les espaces (dans les expressions mathmatiques, par exemple)
str=str.replace(/\ +/g,'');
		//str=rpAll(str,/X/g,'x');//standardiser les signes de multiplication
str=str.replace(/X/g,'x');
		}
	else str=str.replace(/  +/g,' ');//si les espaces comptent, enlever les espaces conscutifs
	str=str.replace(/^\s+/,"").replace(/\s+$/,"");//enlever les espaces restant ventuellement devant et derrire
	if(firstCharCaseInsensitive) {
		str=str.substring(0,1).toUpperCase()+str.substring(1,str.length)
		}
	return str;
	}
/*
function rpAl(sPhrase,regex,sReplacement){
while(regex.test(sPhrase)) {
		sPhrase=sPhrase.replace(regex,sReplacement);
		if(regexReplaceBehaviorCode) regex.test(sPhrase);	
		}
return sPhrase;
}
*/

function clearIt(questionPhrase,identifier){
	var t=document.getElementById(identifier);
	if(preRed) t.style.backgroundColor="rgb(250,50,50)";
	else t.style.backgroundColor="white";
	t.value=questionPhrase;
	}



function helpIt(j){
	alert(helpPhrases[j]);
	if(scoreStatus[j]<1) scoreStatus[j]--;
	}



function tellIt(j){
	alert(rightAnswers[j]);
	if(scoreStatus[j]<1) scoreStatus[j]--;
	}



function getShuffleBase(size){
	var shuffleArray=new Array(size);
	for(var i=0;i<size;i++)shuffleArray[i]=Math.random()+"a"+i;
	shuffleArray.sort();
	for(var i = 0;i<size;i++)shuffleArray[i]=shuffleArray[i].substring(shuffleArray[i].indexOf("a")+1,shuffleArray[i].length);
	return shuffleArray;
	}


function shuffleArray(ar, shuffleBase){
	var size=ar.length;
	var result=new Array(size);
	for(var i = 0;i<size;i++) result[i]=ar[shuffleBase[i]];
	return result;
	}
